<?php

namespace Runtime;

use Runtime\Factory\BootstrapFactory;

class Bootstrap {

    /**
     * @var BootstrapFactory
     */
    private static $instance;

    /**
     * Start handling process
     *
     * @return BootstrapFactory
     */
    public static function createInstance()
    {
        self::$instance = (new Bootstrap())->run();

        return Bootstrap::getInstance();
    }

    /**
     * @return BootstrapFactory
     */
    public static function getInstance()
    {
        return self::$instance;
    }

    /**
     * @return BootstrapFactory
     */
    protected function run()
    {
        return new BootstrapFactory();
    }
}