<?php

namespace Runtime\Http\Controllers;

use BadMethodCallException;
use Runtime\Http\Response;

abstract class Controller {

    /**
     * @param  string  $method
     * @param  array   $parameters
     * @return Response
     */
    public function callAction($method, $parameters)
    {
        return call_user_func_array([$this, $method], $parameters);
    }

    /**
     * @param  string  $method
     * @param  array   $parameters
     * @return mixed
     *
     * @throws \BadMethodCallException
     */
    public function __call($method, $parameters)
    {
        throw new BadMethodCallException(sprintf(
            'Method %s::%s does not exist.', static::class, $method
        ));
    }

}