<?php

namespace Runtime\Http\View;

use Runtime\Exceptions\ExceptionHandler;
use Runtime\Factory\AppFactory;
use Twig\Error\LoaderError;
use Twig\Error\RuntimeError;
use Twig\Error\SyntaxError;

class Factory extends AppFactory implements \Runtime\Contracts\View\Factory {

    /**
     * @var string
     */
    private $name;

    /**
     * @var array
     */
    private $arguments;

    /**
     * @param $name
     * @param array $arguments
     * @return string
     */
    public function make($name, $arguments = [])
    {
        $this->name = $name;
        $this->arguments = $arguments;

        try {
                return $this->render();
        }
        catch (\Exception $e) {
            ExceptionHandler::make($e);
        }
    }

    /**
     * @return string
     * @throws LoaderError
     * @throws RuntimeError
     * @throws SyntaxError
     */
    private function render()
    {
        return app()->view()->render($this->name, $this->arguments);
    }
}